%global _hardened_build 1

%define current_version 7.0.103.1

%define lib_include_path prlxmlmodel

Summary: Virtuozzo Xml Model library
Name: libprlxmlmodel
Version: %{current_version}
Release:        1%{?dist}

Group: Development/Libraries
License: LGPLv2.1
Source: %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: make
BuildRequires: gcc-c++
BuildRequires: qt4-devel
BuildRequires: libprlsdk-headers >= 7.0.61
BuildRequires: python2, python2-configparser
BuildRequires: libprlcommon-devel
BuildRequires: boost-devel
ExclusiveArch: x86_64


%description
An object model for Virtuozzo middleware components.

%package devel
Summary: Libraries, includes to compile with the Virtuozzo Xml Model library.
Group: Development/Libraries
License: LGPLv2.1
Requires: %{name} = %{version}-%{release}
Requires: libprlsdk-headers, libprlcommon-devel

%description devel
Include header files & development libraries for the Virtuozzo Xml Model library.

%prep
%setup -q


%build
export PREFIX=%{buildroot}/%{_usr}
%qmake_qt4
%make_build release

%install
rm -rf %{buildroot}
%make_install

%check
cd Tests
%qmake_qt4
make check TESTRUNNER="LD_LIBRARY_PATH=."

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_libdir}/libprl_xml_model.so.*

%files devel
%defattr(-, root, root)
%{_libdir}/libprl_xml_model.so
%dir %{_includedir}/%{lib_include_path}
%{_includedir}/%{lib_include_path}/*

%changelog
* Thu Mar 21 2024 Aleksandr Leskin <aleksandr.leskin@virtuozzo.com> 7.0.103.1
 - cpufeature: Add support of 0x00000007:0 (ECX) intel cpu features #PSBM-153799

* Wed Sep 13 2023 Aleksandr Leskin <aleksandr.leskin@virtuozzo.com> 7.0.102
 - DspCfg: append backup parameters compression and tunnel (#PSBM-150576 #PSBM-150577)

* Mon Apr 17 2023 Aleksandr Leskin <aleksandr.leskin@virtuozzo.com> 7.0.101
 - update copyrights date #PSBM-144949
 - build: remove Warnings [-Wliteral-suffix] added by '-std=c++11' flag
 - vmconfig: Introduce VM parameter OnEfiUpdateAction #PSBM-144949
 - vmconfig: Introduce libvirt lifecycle actions into VM config #PSBM-144949
 - build: append -std=c++11 flag
 - update target list to vz7-u20

* Thu Feb 10 2022 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 7.0.100
 - add Clipboard Boolean parameter for Dispatcher Remote Display configuration
\#PSBM-138284 (Aleksandr Leskin <aleksandr.leskin@virtuozzo.com>)

* Fri Feb 04 2022 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 7.0.99
 - added comparing state of Firewal for comparing Network Adapters #PSBM-136394
(Aleksandr Leskin <aleksandr.leskin@virtuozzo.com>)

* Fri Sep 17 2021 Dmitry Mishin <dim@virtuozzo.com> 7.0.98
 - PSBM-132834 Add BackupMode parameter in BackupSourcePreferences (Efim
   Shevrin <efim.shevrin@virtuozzo.com>)

* Thu Apr 29 2021 Dmitry Mishin <dim@virtuozzo.com> 7.0.97
 - UNIX socket path too long #PSBM-129010 (Igor Sukhih <igor@virtuozzo.com>)
 - Failed to backup Vm with serial port in socket mode #PSBM-128650 (Igor Sukhih
<igor@virtuozzo.com>)

* Tue Apr 13 2021 Dmitry Mishin <dim@virtuozzo.com> 7.0.94
 - PSBM-101424. Keep login in xmlmodel (Aleksandr Alekseev
<alexander.alekseev@virtuozzo.com>)

* Mon Apr 05 2021 Dmitry Mishin <dim@virtuozzo.com> 7.0.93
 - Rename vm socket in /tmp dir (Efim <efim.shevrin@virtuozzo.com>)

* Thu Dec 03 2020 Igor Sukhih <igor@virtuozzo.com> 7.0.92
 - add filterref and params to model (Aleksandr Alekseev
<alexander.alekseev@virtuozzo.com>)
 - add generated files to .gitignore (Aleksandr Alekseev
<alexander.alekseev@virtuozzo.com>)

* Tue Jul 07 2020 Igor Sukhih <igor@virtuozzo.com> 7.0.88
 - Libvirt <bandwidth> representation in xmlmodel #PSBM-105242

* Thu May 14 2020 Igor Sukhih <igor@virtuozzo.com> 7.0.87
 - Add per VE 'backup path' property #PSBM-102716 (Yuriy Pudgorodskiy
<yur@virtuozzo.com>)

* Wed May 06 2020 Igor Sukhih <igor@virtuozzo.com> 7.0.86
 - Add libvirt virtualport repersentation #PSBM-103485

* Mon Mar 30 2020 Dmitry Mishin <dim@virtuozzo.com> 7.0.85
 - Rename Parallels to Virtuozzo #PSBM-102329 (Dmitry Nesterenko
<dmitry.nesterenko@virtuozzo.com>)

* Thu Jan 16 2020 Dmitry Mishin <dim@virtuozzo.com> 7.0.84
 - Remove unused import
 - Explicitly set python2 fro python interpritator (Igor Sukhih
<igor@virtuozzo.com>)
 - Adopt python code for python3 (Igor Sukhih <igor@virtuozzo.com>)
 - Add python2-configparser build requirements
 - Explicitly require python2

* Thu Jan 16 2020 Dmitry Mishin <dim@virtuozzo.com> 7.0.83
 - Explicitly set python2 for python interpretator (Igor Sukhih
<igor@virtuozzo.com>)
 - Adopt python code for python3 (Igor Sukhih <igor@virtuozzo.com>)

* Wed Aug 07 2019 Sergey Galas' <shrike@virtuozzo.com> 7.0.82
 - bug #PVA-37420 aka Automator Web error during backup: "Failed to load
Virtuozzo SDK" (Sergey Galas <shrike@virtuozzo.com>)
 - Update copyright (Igor Sukhih <igor@virtuozzo.com>)

* Fri Feb 15 2019 Igor Sukhih <igor@virtuozzo.com> 7.0.81
- Increase timeout for VmGuestCollectPeriod #PSBM-91710

* Mon Jan 28 2019 Sergey Galas' <shrike@virtuozzo.com> 7.0.80
 - Failed to restore CT backup created on VZ6 #PSBM-91164 (Igor Sukhih
<igor@virtuozzo.com>)

* Thu Jan 24 2019 Sergey Galas' <shrike@virtuozzo.com> 7.0.79
 - PSBM-90858 Add missed copy of 0000007_EDX in XmlModel Zero value was observed
in result (Konstantin B. Bukharov <bkb@virtuozzo.com>)

* Wed Nov 14 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.78
 - Fix PSBM-89902 - return back low min security level (Konstantin B. Bukharov
<bkb@virtuozzo.com>)

* Fri Nov 02 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.77
 - another disk emulation type (Sergey Galas <shrike@virtuozzo.com>)

* Fri Nov 02 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.76
 - bug #PSBM-89788 aka VEBackupSuite.BackupSuite.backup_restore_pcs6 FAIL:
prlctl restore returned 255 (Sergey Galas <shrike@virtuozzo.com>)

* Wed Oct 31 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.75
 - bug #PSBM-89791 aka Failed to read /vz/private/39b40805-7df1-4cae-adae-
e318635f66fb/root. Exit code: 162 (Sergey Galas <shrike@virtuozzo.com>)

* Mon Oct 29 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.74
 - VmConfiguration::setRelativePath(): use custom path #PSBM-89711 (Igor Sukhih
<igor@virtuozzo.com>)

* Fri Feb 09 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.73
 - chipset alias (Sergey Galas <shrike@virtuozzo.com>)

* Fri Feb 02 2018 Sergey Galas' <shrike@virtuozzo.com> 7.0.72
 - merge from VZ6: MAJOR expose SPEC_CTRL to guests if supported @nowidth
(Konstantin B. Bukharov <bkb@virtuozzo.com>)
 - Technical release bump for Rosplatforma build (Denis Silakov
<dsilakov@virtuozzo.com>)

* Fri Oct 27 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.71
 - disabled cpu features in xml model (Sergey Galas <shrike@virtuozzo.com>)

* Thu Sep 07 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.70
 - PSBM-60166 Change default security level to high (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Tue Jun 20 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.69
 - bug #PSBM-66500 aka Support for CPU topology configuration (Sergey Galas
<shrike@virtuozzo.com>)

* Thu Jun 08 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.68
 - Sync BasePort with remote_display_port_min #PSBM-67100 (Igor Sukhih
<igor@virtuozzo.com>)

* Wed Jun 07 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.67
 - Sync BasePort with remote_display_port_min #PSBM-67100 (Igor Sukhih
<igor@virtuozzo.com>)

* Wed May 24 2017 Andrey Bondrov <abondrov@virtuozzo.com> 7.0.66-2
- Enable hardened build, see #PSBM-58107

* Tue May 23 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.66
 - MaxPort should not be mandatory paramter #PSBM-66556 (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>)

* Fri Apr 07 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.64
 - High security level mode is broken in the product now: PSBM-63967, PSBM-63973

* Thu Apr 06 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.63
 - Limit VNC ports range #PSBM-63821
 - Change default security level to high #PSBM-60166

* Thu Apr 06 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.62
 - bug #PSBM-63844 aka Unable to pre-create chardev file
/vz/vmprivate/....restore/serial.txt (Sergey Galas <shrike@virtuozzo.com>)

* Thu Apr 06 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.61
 - Limit VNC ports range #PSBM-63821 (Igor Sukhih <igor@virtuozzo.com>)

* Wed Apr 05 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.59
 - bug #PSBM-63557 aka  Failed to migrate the VM: Operation failed. Failed to
execute the operation. (Details: Un ... (Sergey Galas <shrike@virtuozzo.com>)

* Wed Mar 29 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.58
- Move branding to separate file, see #PSBM-58317

* Wed Mar 22 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.57
 - Remove disk uuid autogeneration #PSBM-55314 (Igor Sukhih
<igor@virtuozzo.com>)

* Fri Mar 17 2017 Sergey Galas' <shrike@virtuozzo.com> 7.0.56
 - Update copyrights ( #PSBM-58317 ) (Andrey Bondrov <abondrov@virtuozzo.com>)

* Thu Dec 29 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.55
 - Use *report.virtuozzo.com instead of *report.parallels.com (Denis Silakov
<dsilakov@virtuozzo.com>)
 - Add memory policy structure to xml model (PSBM-55022) (Pavel Ganyushin
<pganyushin@virtuozzo.com>)

* Thu Dec 15 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.54
 - add crash limit field (PSBM-55697) (Pavel Ganyushin
<pganyushin@virtuozzo.com>)
 - add virtual network adapters to host hardware info (PSBM-53561) (Pavel
Ganyushin <pganyushin@virtuozzo.com>)

* Wed Dec 14 2016 Konstantin Volkov <wolf@virtuozzo.com> - 7.0.53-2
- Rebuild in 7.3 environment

* Thu Nov 24 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.53
 - disable video 3d accelleration by default as it is not supported now (Maxim
Nestratov <mnestratov@virtuozzo.com>) (#PVA-35957)

* Wed Oct 12 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.52
 - Add VNC websocket port in VM config, #PSBM-53289 (Maxim Perevedentsev
<mperevedentsev@virtuozzo.com>)

* Tue Oct 11 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.50
 - Added label field to CD type (Alexander Burluka <aburluka@virtuozzo.com>) (#PSBM-51466)

* Fri Oct 07 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.49
 - Store real hdd size in sectors #PSBM-53201 (Igor Sukhih <igor@virtuozzo.com>)

* Fri Sep 30 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.48
 - DispConfig: add debug mode for Vz6 upgrade operations (Dmitry Andreev
<dandreev@virtuozzo.com>)

* Wed Sep 28 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.47
 - Add on-crash action parameter (PSBM-51080) (Pavel Ganyushin
<pganyushin@virtuozzo.com>)
 - Remove minOccurs limit from Encryption element (PSBM-50720) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)
 - Add disk encryption parameters to GetBackupTree result (PSBM-50720) (Igor
Bazhitov <ibazhitov@virtuozzo.com>)
 - change default CPU mode both for host and guest (VMs and CTs) to x64 (Maxim
Nestratov <mnestratov@virtuozzo.com>)

* Mon Sep 05 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.46
 - Refactor: move CVmEvent*, BaseNode to libprlcommon

* Mon Aug 29 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.45
 - network: rename PNA_BRIDGED_ETHERNET to PNA_BRIDGED_NETWORK (Maxim Nestratov
<mnestratov@virtuozzo.com>)

* Thu Aug 25 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.44
 - Remove dependency on SDK development library in tests
 - Alias fix (Alexander Burluka <aburluka@virtuozzo.com>) (#PSBM-51246)

* Mon Jul 18 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.42

* Wed Jul 06 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.40
 - bug #PSBM-49009 aka prl_disp should not overwrite memory stats update period
after vcmmd (Sergey Galas <shrike@virtuozzo.com>)

* Mon Jul 04 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.39
 - Introduce new disk encryption type (PSBM-44176) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)

* Fri Jul 01 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.38
 - Use tmp directory for serial device of socket mode #PSBM-49140 (Dmitry
Andreev <dandreev@virtuozzo.com>)

* Sat Jun 25 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.37
 - Add network shaping and network classes config to CDispConfig #PSBM-42178
(Dmitry Andreev <dandreev@virtuozzo.com>)

* Fri Jun 24 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.36
 - Get rid of old disk encryption interface (PSBM-48677) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)

* Wed Jun 22 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.35
 - coverity-125307 Uninitialized scalar field (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - coverity-125304 Uninitialized scalar field (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - coverity-125279 remove InterfaceInfo (Dmitry Andreev
<dandreev@virtuozzo.com>)

* Mon Jun 20 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.34
 - coverity-125296 Mixing enum types (Dmitry Andreev <dandreev@virtuozzo.com>)
 - coverity-125297 Uninitialized scalar field (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - coverity-125298-125308 Uninitialized scalar field (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - covarity-125309 Uninitialized scalar field (Dmitry Andreev
<dandreev@virtuozzo.com>)
 - Fix uninitialized values in ctor (coverity-125310) (Dmitry Andreev
<dandreev@virtuozzo.com>)

* Sat Jun 18 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.33
 - Continuation of commit 39de4b9b - PartialBackupItem should have Flags as well (#PSBM-48367 #PSBM-48503)

* Fri Jun 17 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.32
 - Enhance BackupItem element for new scheme (Dmitry Mishin <dim@virtuozzo.com>) (#PSBM-48367 #PSBM-48506 #PSBM-48503)

* Fri Jun 10 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.31
 - Add GuestLimitType field to CVmCpu (Dmitry Andreev <dandreev@virtuozzo.com>) (#PSBM-45713)

* Sat Jun 04 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.30
 - Add CPU features setter #PSBM-47890 (Dmitry Andreev <dandreev@virtuozzo.com>)

* Fri Jun 03 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.29
 - Extend VtInfo, add required CPU features and CPU model (Alexander Burluka
<aburluka@virtuozzo.com>) (#PSBM-47573)

* Thu Jun 02 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.28
 - Add MaxVCpu node to CpuPreferences scheme #PSBM-47890 (Dmitry Andreev
<dandreev@virtuozzo.com>)

* Fri May 20 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.27
 - Properly add device alias to HDD schema (PSBM-44137) (Igor Bazhitov
<ibazhitov@virtuozzo.com>)

* Sat May 14 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.26
 - Add backup protocol version PSBM-47123

* Fri May 13 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.25
 - Additional fix to headers cleanup

* Fri May 13 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.24
 - Add MigrationInstanceId to DiskDescriptor xml schema. (Dmitry Andreev
<dandreev@virtuozzo.com>) (#PSBM-40857)

* Fri May 13 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.23
 - Fixed headers duplication on 'make install'

* Thu May 12 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.22
 - Change default clustered device subtype to PCD_VIRTIO_SCSI (PSBM-46975) (Igor
Bazhitov <ibazhitov@virtuozzo.com>)

* Mon Apr 25 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.21
 - Add node mask to VM config. #PSBM-39268 (Alexander Pisarev
   <apisarev@virtuozzo.com>)

* Mon Apr 11 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.20
 - Return back EnvId field for Containers migration from Vz 6 (#PSBM-45982)

* Tue Apr 05 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.19
 - Rename netfilter field MAC to avoid collision, #PSBM-5969 (Maxim
Perevedentsev <mperevedentsev@virtuozzo.com>)

* Mon Apr 04 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.18
 - bug #PSBM-45780 (Sergey Galas <shrike@virtuozzo.com>)
 - Add MAC to CNetPktFilter for guest bonding, #PSBM-5969 (Maxim Perevedentsev
<mperevedentsev@virtuozzo.com>)

* Sat Apr 02 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.16
 - Add MAC to CNetPktFilter for guest bonding, #PSBM-5969 (Maxim Perevedentsev
<mperevedentsev@virtuozzo.com>)

* Thu Mar 10 2016 Sergey Galas' <shrike@virtuozzo.com> 7.0.15
 - Added COPYING file (Dmitry Mishin <dim@virtuozzo.com>)
 - Add CPU limit type to VtInfo structure (Alexander Burluka
<aburluka@virtuozzo.com>) (#PSBM-42077)

* Tue Mar 01 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.12
 - Support SocketMode for serial device with SerialTCP emulation type
   \#PSBM-43039 (Dmitry Andreev <dandreev@virtuozzo.com>)
 - Properly link with distribution-specific version of boost libraries (Igor
   Bazhitov <ibazhitov@virtuozzo.com>)

* Mon Feb 22 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.11
 - Add alias field to CVmDevice (Alexander Burluka <aburluka@virtuozzo.com>)

* Sun Feb 21 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.10
 - add backup activity sources to build (Sergey Galas <shrike@odin.com>)
 - Drop xsd2src/Makefile* during distclean (Denis Silakov <dsilakov@gmail.com>)

* Tue Feb 16 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.8
 - bug #PSBM-44149 (Sergey Galas <shrike@odin.com>)

* Mon Feb 15 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.7
 - bug #PSBM-44149 (Sergey Galas <shrike@odin.com>)
 - Allow picking up build dependencies from non-system locations (Denis Silakov
<dsilakov@gmail.com>)

* Tue Jan 19 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.6
 - Add host mhz information into virtualization info (Alexander Burluka
<aburluka@virtuozzo.com>)

* Mon Jan 18 2016 Igor Sukhih <igor@parallels.com> 7.0.5
 - Add MemGuarantee fields to VmConfig scheme. #PSBM-42535

* Tue Jan 12 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.4
 - Fixed persistent project files to export headers as well

* Tue Jan 12 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.3
 - Added XmlModel tests from prl-disp-service project

* Mon Jan 11 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.2
 - Initial commit

